From a5a15d32f4f7407687177756b2361e4274e07b73 Mon Sep 17 00:00:00 2001
From: Friedemann Kleint <Friedemann.Kleint@qt.io>
Date: Wed, 19 Jun 2019 13:00:11 +0200
Subject: [PATCH 2/3] WIP: Extract QGuiAction(Group) from QAction(Group) into
 QtGui

Simply moving QAction to QtGui was not deemed possible since it
operates on a set of controls of some kind. The approach to extract a
base class was taken instead, named QGuiAction following the
QGuiApplication scheme. QAction remains in widgets, but changes base
class.

For QActionGroup, the functions addAction(text/icon), which create an
action, cannot be implemented in QtGui, hence a base class is needed,
too (unless they are deprecated and removed).

- Extract base classes providing functionality not based on
  QtWidgets, using virtuals in QGuiActionPrivate to
  provide customization points

- Change QActionEvent to take QGuiAction, removing
  the need to forward declare QAction in QtGui

- Notes
   * Introduces some ugly casts to widgets

TODO : split tests

Task-number: QTBUG-69478
Change-Id: Ic490a5e3470939ee8af612d46ff41d4c8c91fbdf
---
 src/gui/kernel/kernel.pri                     |    6 +
 src/gui/kernel/qevent.cpp                     |   10 +-
 src/gui/kernel/qevent.h                       |   10 +-
 src/gui/kernel/qguiaction.cpp                 | 1214 +++++++++++++++++
 src/gui/kernel/qguiaction.h                   |  199 +++
 src/gui/kernel/qguiaction_p.h                 |  127 ++
 src/gui/kernel/qguiactiongroup.cpp            |  349 +++++
 src/gui/kernel/qguiactiongroup.h              |  107 ++
 src/gui/kernel/qguiactiongroup_p.h            |   91 ++
 src/widgets/graphicsview/qgraphicswidget.h    |    1 +
 src/widgets/kernel/qaction.cpp                | 1064 +--------------
 src/widgets/kernel/qaction.h                  |  124 +-
 src/widgets/kernel/qaction_p.h                |   47 +-
 src/widgets/kernel/qactiongroup.cpp           |  304 +----
 src/widgets/kernel/qactiongroup.h             |   37 +-
 src/widgets/styles/qstyleoption.cpp           |    2 +-
 src/widgets/widgets/qlineedit_p.cpp           |    6 +-
 src/widgets/widgets/qlineedit_p.h             |    4 +-
 src/widgets/widgets/qmenu.cpp                 |   12 +-
 src/widgets/widgets/qmenubar.cpp              |   17 +-
 src/widgets/widgets/qtoolbar.cpp              |    2 +-
 src/widgets/widgets/qtoolbarlayout.cpp        |    2 +-
 src/widgets/widgets/qtoolbarlayout_p.h        |    2 +-
 src/widgets/widgets/qtoolbutton.cpp           |    2 +-
 .../widgets/kernel/qaction/tst_qaction.cpp    |    2 +-
 .../kernel/qactiongroup/tst_qactiongroup.cpp  |    2 +-
 26 files changed, 2200 insertions(+), 1543 deletions(-)
 create mode 100644 src/gui/kernel/qguiaction.cpp
 create mode 100644 src/gui/kernel/qguiaction.h
 create mode 100644 src/gui/kernel/qguiaction_p.h
 create mode 100644 src/gui/kernel/qguiactiongroup.cpp
 create mode 100644 src/gui/kernel/qguiactiongroup.h
 create mode 100644 src/gui/kernel/qguiactiongroup_p.h

diff --git a/src/gui/kernel/kernel.pri b/src/gui/kernel/kernel.pri
index 9c80f1e2cc..d70b1ea13b 100644
--- a/src/gui/kernel/kernel.pri
+++ b/src/gui/kernel/kernel.pri
@@ -33,6 +33,10 @@ HEADERS += \
         kernel/qplatformnativeinterface.h \
         kernel/qplatformmenu.h \
         kernel/qsurfaceformat.h \
+        kernel/qguiaction.h \
+        kernel/qguiaction_p.h \
+        kernel/qguiactiongroup.h \
+        kernel/qguiactiongroup_p.h \
         kernel/qguiapplication.h \
         kernel/qguiapplication_p.h \
         kernel/qwindow_p.h \
@@ -98,6 +102,8 @@ SOURCES += \
         kernel/qplatformnativeinterface.cpp \
         kernel/qsessionmanager.cpp \
         kernel/qsurfaceformat.cpp \
+        kernel/qguiactiongroup.cpp \
+        kernel/qguiaction.cpp \
         kernel/qguiapplication.cpp \
         kernel/qwindow.cpp \
         kernel/qoffscreensurface.cpp \
diff --git a/src/gui/kernel/qevent.cpp b/src/gui/kernel/qevent.cpp
index e1d685b1b0..d116ec0855 100644
--- a/src/gui/kernel/qevent.cpp
+++ b/src/gui/kernel/qevent.cpp
@@ -3470,18 +3470,18 @@ QWhatsThisClickedEvent::~QWhatsThisClickedEvent()
 /*!
     \class QActionEvent
     \brief The QActionEvent class provides an event that is generated
-    when a QAction is added, removed, or changed.
+    when a QGuiAction is added, removed, or changed.
 
     \ingroup events
     \inmodule QtGui
 
-    Actions can be added to widgets using QWidget::addAction(). This
-    generates an \l ActionAdded event, which you can handle to provide
+    Actions can be added to controls, for example by using QWidget::addAction().
+    This generates an \l ActionAdded event, which you can handle to provide
     custom behavior. For example, QToolBar reimplements
     QWidget::actionEvent() to create \l{QToolButton}s for the
     actions.
 
-    \sa QAction, QWidget::addAction(), QWidget::removeAction(), QWidget::actions()
+    \sa QGuiAction, QWidget::addAction(), QWidget::removeAction(), QWidget::actions()
 */
 
 /*!
@@ -3492,7 +3492,7 @@ QWhatsThisClickedEvent::~QWhatsThisClickedEvent()
     type is ActionAdded, the action is to be inserted before the
     action \a before. If \a before is 0, the action is appended.
 */
-QActionEvent::QActionEvent(int type, QAction *action, QAction *before)
+QActionEvent::QActionEvent(int type, QGuiAction *action, QGuiAction *before)
     : QEvent(static_cast<QEvent::Type>(type)), act(action), bef(before)
 {}
 
diff --git a/src/gui/kernel/qevent.h b/src/gui/kernel/qevent.h
index eb0a6208a9..bd0632ef3f 100644
--- a/src/gui/kernel/qevent.h
+++ b/src/gui/kernel/qevent.h
@@ -59,7 +59,7 @@
 QT_BEGIN_NAMESPACE
 
 
-class QAction;
+class QGuiAction;
 #ifndef QT_NO_GESTURES
 class QGesture;
 #endif
@@ -727,13 +727,13 @@ private:
 #ifndef QT_NO_ACTION
 class Q_GUI_EXPORT QActionEvent : public QEvent
 {
-    QAction *act, *bef;
+    QGuiAction *act, *bef;
 public:
-    QActionEvent(int type, QAction *action, QAction *before = nullptr);
+    QActionEvent(int type, QGuiAction *action, QGuiAction *before = nullptr);
     ~QActionEvent();
 
-    inline QAction *action() const { return act; }
-    inline QAction *before() const { return bef; }
+    inline QGuiAction *action() const { return act; }
+    inline QGuiAction *before() const { return bef; }
 };
 #endif
 
